<script lang="ts">
  import { Button, Tooltip } from 'flowbite-svelte';
  import Fa from 'svelte-fa';
  import { faArrowUpFromBracket } from '@fortawesome/free-solid-svg-icons';
  import { TeamsByIdStore } from '$houdini';
  import Spinner from './Spinner.svelte';

  export let teamIds: string[];
  export let filename = "teams";
  export let appendTimestamp = true;
  export let includeHeaders = true;
  export let separator = ',';

  let loading = false;

  async function download_blob() {
    loading = true;
    const blob = new Blob([await export_teams_csv()], {type: "text/csv"});
    const fileUrl = window.URL.createObjectURL(blob);
    const now = new Date();
    const timestamp = ' ' + now.getFullYear() +
      '-' + String(now.getMonth() + 1).padStart(2, '0') +
      '-' + String(now.getDate()).padStart(2, '0') +
      '_' + String(now.getHours()).padStart(2, '0') +
      '-' + String(now.getMinutes()).padStart(2, '0');

    // Stack Overflow hack to get the file contents as a download
    // https://stackoverflow.com/questions/3749231/download-file-using-javascript-jquery
    const a = document.createElement('a');
    a.style.display = 'none';
    a.href = fileUrl;
    a.download = filename + (appendTimestamp ? timestamp : '') + '.csv';
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
    loading = false;
  }

  type User = {
    first_name: string;
    last_name: string;
    email?: string;
    discord_linked?: boolean;
  }

  function formatUserAsMailbox(user: User | null): string {
    if(!user) return '';

    return `${user.first_name || ''} ${user.last_name || ''} <${user.email}>`;
  }

  async function export_teams_csv() {
    const headers = [
      '"Short Name"',
      '"Team Name"',
      '"Institution"',
      '"Created"',
      '"Size"',
      '"Team Lead"',
      '"Liaison"',
      '"Members"',
      '"Discord Linked"',
      '"Discord Not Linked"',
      '"Regions"',
      '"East Region"',
      '"West Region"',
      '"Northeast Region"',
      '"Southeast Region"',
      '"Midwest Region"',
      '"Northwest Region"',
      '"Southwest Region"',
    ]
    const lines: string[] = []
    if (includeHeaders) {
      lines.push(headers.join(separator))
    }
    const teamsInterface = new TeamsByIdStore()
    const result = await teamsInterface.fetch({variables: {team_ids: teamIds}})
    if (result.errors) throw result.errors;
      if(!result.data) throw new Error('No data found')
    for (const team of result.data.teams) {
      if (!(team)) {
        throw new Error('Team data malformed')
      }
      const regions = team.institution?.regions.map((v: {region: {name: string}}) => v.region.name) || []
      const line = [
        JSON.stringify(team.name),
        JSON.stringify(team.long_name),
        JSON.stringify(team.institution?.name),
        JSON.stringify(team.created),
        JSON.stringify(team.team_size),
        JSON.stringify(formatUserAsMailbox(team.team_lead as User | null)),
        JSON.stringify(formatUserAsMailbox(team.liaison as User | null)),
        JSON.stringify(team.members.map(u => u.user as User).map(formatUserAsMailbox).join('; ')),
        JSON.stringify(team.members.map(u => u.user as User).filter(u => u.discord_linked).map(formatUserAsMailbox).join('; ')),
        JSON.stringify(team.members.map(u => u.user as User).filter(u => !u.discord_linked).map(formatUserAsMailbox).join('; ')),
        JSON.stringify(regions.join(';')),
        JSON.stringify(regions.includes('east') ? 'x' : ''),
        JSON.stringify(regions.includes('west') ? 'x' : ''),
        JSON.stringify(regions.includes('northeast') ? 'x' : ''),
        JSON.stringify(regions.includes('southeast') ? 'x' : ''),
        JSON.stringify(regions.includes('midwest') ? 'x' : ''),
        JSON.stringify(regions.includes('northwest') ? 'x' : ''),
        JSON.stringify(regions.includes('southwest') ? 'x' : ''),
      ].join(separator)
      lines.push(line)
    }
    return lines.join('\n')
  }
</script>

<Button class="p-1" color="green" disabled={loading} on:click={() => {if (!loading) {download_blob()}}} >
  {#if loading}
    <Spinner size=4 />
  {:else}
    <Fa class="pr-1" icon={faArrowUpFromBracket}></Fa>
  {/if}

  Export
</Button>
<Tooltip class="px-2">Export Team Data</Tooltip>
